summary refs log tree commit diff
path: root/pkgs/build-support/appimage
diff options
context:
space:
mode:
authorBignaux Ronan <ronan@aimao.org>2020-03-05 23:57:36 +0100
committerBignaux Ronan <ronan@aimao.org>2020-03-07 20:24:26 +0100
commitb36d3f2c4a94a5e5002fb0647db5465e7c38668b (patch)
tree48c7a8789f1d5bb2c5617dfff20593f98b612fb7 /pkgs/build-support/appimage
parent349e923e00cf46fa33f118bfd22024f392e95a79 (diff)
downloadnixpkgs-b36d3f2c4a94a5e5002fb0647db5465e7c38668b.tar
nixpkgs-b36d3f2c4a94a5e5002fb0647db5465e7c38668b.tar.gz
nixpkgs-b36d3f2c4a94a5e5002fb0647db5465e7c38668b.tar.bz2
nixpkgs-b36d3f2c4a94a5e5002fb0647db5465e7c38668b.tar.lz
nixpkgs-b36d3f2c4a94a5e5002fb0647db5465e7c38668b.tar.xz
nixpkgs-b36d3f2c4a94a5e5002fb0647db5465e7c38668b.tar.zst
nixpkgs-b36d3f2c4a94a5e5002fb0647db5465e7c38668b.zip
appimage: replace writeScript to a standalone appimage-exec.sh
Diffstat (limited to 'pkgs/build-support/appimage')
-rwxr-xr-xpkgs/build-support/appimage/appimage-exec.sh129
-rw-r--r--pkgs/build-support/appimage/default.nix68
2 files changed, 150 insertions, 47 deletions
diff --git a/pkgs/build-support/appimage/appimage-exec.sh b/pkgs/build-support/appimage/appimage-exec.sh
new file mode 100755
index 00000000000..fd38889b9aa
--- /dev/null
+++ b/pkgs/build-support/appimage/appimage-exec.sh
@@ -0,0 +1,129 @@
+#!@shell@
+if [ ! -z "$DEBUG" ] ; then
+  set -x
+fi
+
+export PATH=@path@
+
+# src : AppImage
+# dest : let's unpack() create the directory
+unpack() {
+  src=$1
+  out=$2
+
+  # https://github.com/AppImage/libappimage/blob/ca8d4b53bed5cbc0f3d0398e30806e0d3adeaaab/src/libappimage/utils/MagicBytesChecker.cpp#L45-L63
+  eval "$(r2 "$src" -nn -Nqc "p8j 3 @ 8" |
+    jq -r '{appimageSignature: (.[:-1]|implode), appimageType: .[-1]}|
+      @sh "appimageSignature=\(.appimageSignature) appimageType=\(.appimageType)"')"
+
+  # check AppImage signature
+  if [[ "$appimageSignature" != "AI" ]]; then
+    echo "Not an appimage."
+    exit -1
+  fi
+
+  case "$appimageType" in
+    1)  echo "Uncompress $(basename "$src") of Type: $appimageType."
+        mkdir "$out"
+        pv "$src" | bsdtar -x -C "$out" -f -
+        ;;
+
+    2)  echo "Uncompress $(basename "$src") of Type: $appimageType."
+        # This method avoid issues with non executable appimages,
+        # non-native packer, packer patching and squashfs-root destination prefix.
+
+        # multiarch offset one-liner using same method as AppImage
+        # see https://gist.github.com/probonopd/a490ba3401b5ef7b881d5e603fa20c93
+        offset=$(r2 "$src" -nn -Nqc "pfj.elf_header @ 0" |\
+          jq 'map({(.name): .value}) | add | .shoff + (.shnum * .shentsize)')
+
+        unsquashfs -q -d "$out" -o "$offset" "$src"
+        chmod go-w "$out"
+        ;;
+
+    # 3) get ready, https://github.com/TheAssassin/type3-runtime
+    *)  echo Unsupported AppImage Type: "$appimageType"
+        exit
+        ;;
+  esac
+  echo "$(basename "$src") is now installed in $out"
+}
+
+apprun() {
+
+  eval "$(rahash2 "$APPIMAGE" -j | jq -r '.[] | @sh "SHA256=\(.hash)"')"
+  echo sha256 = \"$SHA256\"\;
+  export APPDIR="${XDG_CACHE_HOME:-$HOME/.cache}/appimage-run/$SHA256"
+
+  #compatibility
+  if [ -x "$APPDIR/squashfs-root" ]; then APPDIR="$APPDIR/squashfs-root"; fi
+
+  if [ ! -x "$APPDIR" ]; then
+    mkdir -p $(dirname "$APPDIR")
+    unpack "$APPIMAGE" "$APPDIR"
+  fi
+
+  echo $(basename "$APPIMAGE") installed in "$APPDIR"
+
+  export PATH="$PATH:$PWD/usr/bin"
+  wrap
+}
+
+wrap() {
+
+  cd "$APPDIR"
+  # quite same in appimageTools
+  export APPIMAGE_SILENT_INSTALL=1
+
+  if [ -n "$APPIMAGE_DEBUG_EXEC" ]; then
+    exec "$APPIMAGE_DEBUG_EXEC"
+  fi
+
+  exec ./AppRun "$@"
+}
+
+usage() {
+  echo "Usage: appimage-run [appimage-run options] <AppImage> [AppImage options]";
+  echo
+  echo 'Options are passed on to the appimage.'
+  echo "If you want to execute a custom command in the appimage's environment, set the APPIMAGE_DEBUG_EXEC environment variable."
+  exit 1
+}
+
+while getopts ":a:d:xrw" option; do
+    case "${option}" in
+        a)  #AppImage file
+            # why realpath?
+            APPIMAGE="$(realpath "${OPTARG}")"
+            ;;
+        d)  #appimage Directory
+            export APPDIR=${OPTARG}
+            ;;
+        x)  # eXtract
+            unpack_opt=true
+            ;;
+        r)  # appimage-Run
+            apprun_opt=true
+            ;;
+        w)  # WrapAppImage
+            wrap_opt=true
+            ;;
+        *)
+            usage
+            ;;
+    esac
+done
+shift $((OPTIND-1))
+
+if [[ $unpack_opt = true ]] && [[ -f "$APPIMAGE" ]]; then
+  unpack "$APPIMAGE" "$APPDIR"
+  exit
+fi
+
+if [[ $apprun_opt = true ]] && [[ -f "$APPIMAGE" ]]; then
+  apprun
+fi
+
+if [[ $wrap_opt = true ]] && [[ -d "$APPDIR" ]]; then
+  wrap
+fi
diff --git a/pkgs/build-support/appimage/default.nix b/pkgs/build-support/appimage/default.nix
index c56aae4c599..4df0f15d84d 100644
--- a/pkgs/build-support/appimage/default.nix
+++ b/pkgs/build-support/appimage/default.nix
@@ -1,61 +1,35 @@
-{ stdenv, libarchive, radare2, jq, buildFHSUserEnv, squashfsTools, writeScript }:
+{ stdenv, buildFHSUserEnv, writeScript, pkgs
+, bash, radare2, jq, squashfsTools, ripgrep
+, coreutils, libarchive, file, runtimeShell, pv
+, lib, runCommand }:
 
 rec {
-
-  extract = { name, src }: stdenv.mkDerivation {
-    name = "${name}-extracted";
-    inherit src;
-    nativeBuildInputs = [ radare2 libarchive jq squashfsTools ];
-    buildCommand = ''
-      # https://github.com/AppImage/libappimage/blob/ca8d4b53bed5cbc0f3d0398e30806e0d3adeaaab/src/libappimage/utils/MagicBytesChecker.cpp#L45-L63
-      eval $(r2 $src -nn -Nqc "p8j 3 @ 8" |
-        jq -r '{appimageSignature: (.[:-1]|implode), appimageType: .[-1]}|
-          @sh "appimageSignature=\(.appimageSignature) appimageType=\(.appimageType)"')
-
-      # check AppImage signature
-      if [[ "$appimageSignature" != "AI" ]]; then
-        echo "Not an appimage."
-        exit
-      fi
-
-      case "$appimageType" in
-        1)
-          mkdir $out
-          bsdtar -x -C $out -f $src
-          ;;
-
-        2)
-          # multiarch offset one-liner using same method as AppImage
-          # see https://gist.github.com/probonopd/a490ba3401b5ef7b881d5e603fa20c93
-          offset=$(r2 $src -nn -Nqc "pfj.elf_header @ 0" |\
-            jq 'map({(.name): .value}) | add | .shoff + (.shnum * .shentsize)')
-
-          unsquashfs -q -d $out -o $offset $src
-          chmod go-w $out
-          ;;
-
-        # 3) get ready, https://github.com/TheAssassin/type3-runtime
-        *) echo "Unsupported AppImage Type: $appimageType";;
-      esac
-    '';
+  appimage-exec = pkgs.substituteAll {
+    src = ./appimage-exec.sh;
+    isExecutable = true;
+    dir = "bin";
+    path = with pkgs; lib.makeBinPath [ pv ripgrep file radare2 libarchive jq squashfsTools coreutils bash ];
   };
 
+  extract = { name, src }: runCommand "${name}-extracted" {
+    buildInputs = [ appimage-exec ];
+  } ''
+    appimage-exec.sh -x -d $out -a ${src}
+  '';
+
+  # for compatibility, deprecated
   extractType1 = extract;
   extractType2 = extract;
+  #wrapType2 = wrapAppImage;
+  #wrapType1 = wrapAppImage;
 
   wrapAppImage = args@{ name, src, extraPkgs, ... }: buildFHSUserEnv (defaultFhsEnvArgs // {
     inherit name;
 
-    targetPkgs = pkgs: defaultFhsEnvArgs.targetPkgs pkgs ++ extraPkgs pkgs;
-
-    runScript = writeScript "run" ''
-      #!${stdenv.shell}
+    targetPkgs = pkgs: [ appimage-exec ]
+      ++ defaultFhsEnvArgs.targetPkgs pkgs ++ extraPkgs pkgs;
 
-      export APPDIR=${src}
-      export APPIMAGE_SILENT_INSTALL=1
-      cd $APPDIR
-      exec ./AppRun "$@"
-    '';
+    runScript = "appimage-exec.sh -w -d ${src}";
   } // (removeAttrs args (builtins.attrNames (builtins.functionArgs wrapAppImage))));
 
   wrapType1 = args@{ name, src, extraPkgs ? pkgs: [], ... }: wrapAppImage (args // {